import 'package:get/get_rx/src/rx_types/rx_types.dart';
import 'package:getx_extended/extension/source/async.dart';
import 'package:getx_extended/rx/source/rx_visible_startable.dart';

class RxQueryModel<Query, Result> extends Rx<Result>
    implements RxVisibleStartable {
  bool isAutoStart;
  Future<Result> Function(Query query) source;
  Query query;

  RxQueryModel({
    required this.source,
    required this.query,
    required Result defaultValue,
    this.isAutoStart = true,
  }) : super(defaultValue) {
    if (isAutoStart) {
      reloadDataSource();
    }
  }

  Future reloadDataSource({
    Query? updatedQuery,
  }) async {
    if (updatedQuery != null) {
      query = updatedQuery;
    }
    isAutoStart = true;
    final data = await source(query);
    postFrameFuture(() => value = data);
    return data;
  }
}
